// ArchivePlayerDlg.h : Y 
//

#pragma once

#include "ProSliderCtrl.h"
#include "afxcmn.h"
#include "afxwin.h"
#include "SDK10000.h"
#include "VideoWindow.h"
#include <string>
#include "B2.h"

#define FILE_EXT_NONE	0
#define FILE_EXT_RAW	1
#define FILE_EXT_MP4	2

typedef struct 
{
	LONG xSrc;
	LONG ySrc;
	LONG Width;
	LONG Height;
}PTZ_REGION;




// CArchivePlayerDlg ܤ
class CArchivePlayerDlg : public CDialog
{
// غc
public:
	CArchivePlayerDlg(CWnd* pParent = NULL);	// зǫغc禡
	~CArchivePlayerDlg()
	{
		if(m_pFullScreen)
		{
			delete m_pFullScreen;
			m_pFullScreen = NULL;
		}
		if(m_BufOfInverseRGBAimage)
		{
			delete [] m_BufOfInverseRGBAimage;
			m_BufOfInverseRGBAimage = NULL;

		}
	}
// ܤ
	enum { IDD = IDD_ARCHIVEPLAYER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV 䴩

	//CString m_strOutString;

// {X@
protected:
	HICON m_hIcon;

	// ͪT禡
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	//afx_msg void OnNMReleasedcaptureSlider1(NMHDR *pNMHDR, LRESULT *pResult);
	//afx_msg void OnNMOnClickSlider1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMReleasedcaptureSlider2(NMHDR *pNMHDR, LRESULT *pResult);
	// Picture control for display
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedButton5();
	afx_msg void OnBnClickedButton4();
	void GetTimeToStr(time_t time, char *buf ,DWORD millsecond =0);
    void GetTimeToStr1(time_t time1, char *buf1 ,DWORD millsecond =0);
	void GetTimeToStr2(time_t time2, char *buf2);
	
	void OnTimeCodeCB(DWORD TimeCode);  
	void OnTimeCodeCBEx(timeval TimeCodeIncludeMicroseconds);

	void OnFilePlayCompleteCB();	
	void OnImageCB(BYTE* pBuf, DWORD nBufLen, DWORD dwWidth, DWORD dwHeight);
	void OnAfterRenderCB();
	void ResetAll();
	void OnBnEnable(bool bEnable);
	void SetRender(bool IsUserStandardRefresh = false);
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedButton3();
	afx_msg void OnBnClickedButton2();
	afx_msg void OnBnClickedRadio2();
	afx_msg void OnBnClickedRadio1();
	afx_msg void OnBnClickedButton6();
	void GetVideoResolution( DWORD dwResolutionIndex, DWORD* dwWidth, DWORD* dwHeight );
	int StringToken(LPTSTR str, LPCTSTR szToken, char** szArray);
	//bool ReadMP4File(CString csFileName);
	bool mf_PrepareDibBuffer(LPBITMAPINFO *lplpbi, DWORD dwX, DWORD dwY);
	void onPlayRaw();

	void onPlayMP4();
	bool FileNameCheck();
	void RefreshDisplayArea();
	void GetDisplayInfo(int nResolution, RECT& rect, int& nFontSize);
	void SaveImage();
	void _fastcall OnGetRawData( DWORD dwdataType, BYTE* buf, DWORD len );
	static void CALLBACK OnGetRawDataCallback( DWORD UserParam, DWORD dwdataType, BYTE* buf, DWORD len ); 
	//void OnRawDataCB();
   

private:
	// KMpeg4 Handle
	HANDLE m_hKMpeg4;

	BOOL m_bFullWindow;
	// Slide for time
	CProSliderCtrl m_cSCTime;
	//CSliderCtrl m_cSCTime;

	// Play rate slide
	CSliderCtrl m_cSCPlayRate;
	// Display control
	CStatic m_cDisplay;
	// Direction backward
	CButton m_cBnBack;
	// Direction forward
	CButton m_cBnForward;
	// Operation Stop
	CButton m_cBnStop;
	// Operation Pause
	CButton m_cBnPause;
	// File name for play
	CString m_sFileName;
	CString m_sFileName1;
	// File path for exec file
	//char m_szFilePath[4096];
	CString m_csOSDText;
	
public:
	// Render Info
	MEDIA_RENDER_INFO m_mri;
	//
	//RAW_TIMEINFO2 mRawTimeInfo;

	RAW_FILEINFO2 RawFileInfo;
		
private:
	// File complete
	bool m_bFileComplete;
	// Connection config setting
	MEDIA_CONNECTION_CONFIG m_mcc;
	// Begin time
	DWORD m_dwBeginTime;
	// End time
	DWORD m_dwEndTime;
	// Current play rate
	DWORD m_dwPlayRate;
	// Take a shoot or not
	bool m_bSnapShoot;
	// Save file type
	int m_nFileType;
	// String for begin time
	CString m_sBeginTime;
	// End time for play file
	CString m_sEndTime;
	// Current time of playing file
	CString m_sCurrentTime;
    CString mf_sCurrentTime;
	// Duration
	DWORD m_dwDuration;
	// Direction
	bool m_bForward;
	// Position on Slide
	DWORD m_dwSlidePos;
	// Frame by Frame
	bool m_bFBF;
	// Save picture button
	CButton m_cBnPicSave;
	// Font Size
	int m_nFontSize;
	// File ext. type
	int m_nFileExtType;
	// Flag for time code change
	bool m_bTimeCodeChange;
	// Background display brush
	HBRUSH m_hBKBrush;
	HPEN m_hPen;
	BYTE *m_bSaveBuffer;
	DWORD m_dwSaveBufferLen;
	int m_PreNextStatus ;
	
	//Full Screen CWnd
public:
	CVideoWindow* m_pFullScreen;
	HWND m_hFullSCWnd;
	bool m_bFullScreenInRatio;
	//Full Screen Image
	BYTE* m_BufOfInverseRGBAimage;	
   
	bool m_bLoadGov;
	int m_nResolution ;
	DWORD m_dwFpsMode;
	DWORD m_dwFps;
	ULONGLONG m_dwFPSCount;  
	ULONGLONG DateTimeDifference;

	BOOL  m_bIsFullScreen;
	DWORD m_dwBeginMillisecond;
	DWORD m_dwEndMilliSecond;
	
	bool m_bGettingPreviousFrame;
	DWORD m_dwCurrentSecond;
	DWORD m_dwCurrentMiliSecond;
	DWORD m_dwTargetFrameSecond;
	DWORD m_dwTargetFrameMiliSecond;
	DWORD m_dwPreFrameSecond;
	DWORD m_dwPreFrameMilliSecond;
	bool  m_bGoNextFrame;
	bool m_bIsUnVisible;	
   
	
public:
	CEdit m_edtWriteDstPath;
	CString  m_WriteFolderName;
	//afx_msg void OnNMCustomdrawSlider2(NMHDR *pNMHDR, LRESULT *pResult);
	CEdit m_FileName;
	
	CButton m_cBnPre;
	afx_msg void OnBnClickedButton7();  	
	
	afx_msg void OnBnClickedButton8();
	afx_msg void OnBnClickedButton9();
	
	CButton m_checkstrtch;
	afx_msg void OnBnClickedCheck1();
	CButton m_FullScreenControl;
	CButton m_Openfilename;
	//afx_msg void OnNMCustomdrawSlider1(NMHDR *pNMHDR, LRESULT *pResult);
	//CButton m_jpgbmpfile;
	afx_msg void OnBnClickedButton10();    

	//Print Text on Captured image
	CButton m_CheckOSDFileName;
	CButton m_CheckOSDDateTime;   
    CButton m_CheckOSDUserText;
	CEdit m_OSD5Text;
   
	//=====videotype=====
	void OnRawData( DWORD type, BYTE * buf, DWORD buflen )
	{
		static char * token[6] = 
		{
			{_T("UNKNOW")},
			{_T("MPEG4")},
			{_T("AUDIO")},
			{_T("AUDIO")},
			{_T("MJPEG")},
			{_T("H264")}
		};
        
		switch( type )
		{
		case 1:			     
		case 4:
		case 5:
			DWORD m_DurationCount = 0 ;			
			GetDlgItem( IDC_EDIT8 )->SetWindowText( token[type]);
			B2_FRAME*b2header=(B2_FRAME*)buf;
			m_dwFps = b2header->Data.FpsNum; 
			m_nResolution = b2header->Data.Resolution ;
			
			{
			  char token[8];
              sprintf( token,"%d", m_dwFps);
			  GetDlgItem( IDC_EDIT6)->SetWindowText( token);
			}	
			
			if(m_cSCTime.m_bPressed == TRUE )
            {
               m_cSCTime.m_dwSlidePos = m_dwFPSCount;                         
            }
			//KSetRawDataCallback( m_hKMpeg4, 0, NULL );	
        break;
		}
	}

	static void WINAPI OnRawDataCallBack( DWORD h, DWORD type, BYTE * buf, DWORD buflen )
	{
		CArchivePlayerDlg * dlg = (CArchivePlayerDlg *)h;
		if( dlg )
		{
			dlg->OnRawData( type, buf, buflen);
		}
	}  

	BOOL CArchivePlayerDlg::PreTranslateMessage(MSG* pMsg) 
	{
		if(pMsg->message==WM_KEYDOWN && pMsg->wParam==VK_RETURN ) 
		{
           pMsg->wParam=NULL ; 
		}	

        if(m_bFullScreenInRatio!=true||m_bFullWindow!=true)
		{
          if(pMsg->message==WM_KEYDOWN && pMsg->wParam==VK_ESCAPE ) 
		  {
             pMsg->wParam=NULL ; 
		  }
		}		
		m_wndTip.RelayEvent(pMsg);
		return CDialog::PreTranslateMessage(pMsg);
	}

	CEdit m_resolutionf;
	CEdit m_videotypef;
	CEdit m_starttimef;
	CEdit m_endtimef;
	CEdit m_frameratef;

	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	LRESULT OnSLIDER_MLBD( WPARAM wParam, LPARAM lParam ); 
	HWND m_hwnd;
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);	

	CButton m_ToUp;
	CButton m_ToLeft;
	CButton m_ToDown;
	CButton m_ToRight;
	CButton m_DigitalPTZ;
	CButton m_ZoomIn;	
	CButton m_ZoomOut;
	afx_msg void OnBnClickedButton11();
	afx_msg void OnBnClickedButton12();
	afx_msg void OnBnClickedButton13();
	afx_msg void OnBnClickedButton14();
	afx_msg void OnBnClickedButton15();
	

public:
	CString szStrDigitalZoomRate;
	BOOL SREAMING_STATUS_PAUSE ;
	BOOL DigitalPTZEnableStatus;
    PTZ_REGION			m_PTZVideo_MAX;
	PTZ_REGION			m_PTZVideo_Current;
	PTZ_REGION			m_PTZVideo_Last;
	LONG				m_nVideoWidth;
	LONG				m_nVideoHeight;
	LONG				m_nRateW;
	LONG				m_nRateH;	
	
    LONG DigitalZoomIn(LONG nSteps);
	LONG DigitalZoomOut(LONG nSteps);
	LONG DigitalMoveLeft(LONG nSteps);
	LONG DigitalMoveRight(LONG nSteps);
	LONG DigitalMoveUp(LONG nSteps);
	LONG DigitalMoveDown(LONG nSteps);
	void DigitalZoomOutMax(void);
    void SetDigitalZoomResolution(DWORD dzVideoWidth,DWORD dzVideoHeight);

	CEdit m_DigitalZoomRate;

private:
    CToolTipCtrl m_wndTip;

};
